# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from marti_introspection_msgs/NodeInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import marti_introspection_msgs.msg

class NodeInfo(genpy.Message):
  _md5sum = "800cb712abf3e0f84bf282d84b0cf195"
  _type = "marti_introspection_msgs/NodeInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message contains documentation data about a specific node

# The fully qualified node name
string name

# The location the node handle is constructed
string location

# The name of the nodelet manager this is running in, if any
string nodelet_manager

# A human readable description of the node
string description

# A list of each topic used in the node
TopicInfo[] topics

# A list of each parameter used in the node
ParamInfo[] parameters

# A list of each service used in the node
ServiceInfo[] services

================================================================================
MSG: marti_introspection_msgs/TopicInfo
# This message contains documentation data about a topic in a node

# The internal name of the topic
string name

# The external, global name of the topic
string resolved_name

# A human readable description of the topic and how to use it
string description

# Used to group related components
string group

# The name of the message type
string message_type

# If the topic is being advertised, otherwise it is being subscribed to
bool advertised

================================================================================
MSG: marti_introspection_msgs/ParamInfo
# This message contains documentation data about a parameter in a node
uint8 TYPE_XMLRPC=0
uint8 TYPE_DOUBLE=1
uint8 TYPE_STRING=2
uint8 TYPE_INT=3
uint8 TYPE_FLOAT=4
uint8 TYPE_BOOL=5

# The internal name of the parameter
string name

# The external, global name of the parameter
string resolved_name

# A description of the parameter and what it does
string description

# Used to group related components
string group

# The type of parameter using the enums above
uint8 type

# If the parameter is dynamic or not
bool dynamic

# Default values
int32 default_int
float32 default_float
float64 default_double
string default_string
bool default_bool

# Max and minimum values (may have rounding issues)
# Unused if both are 0.0
float64 max_value
float64 min_value

================================================================================
MSG: marti_introspection_msgs/ServiceInfo
# This message contains documentation data about a service client/server in a node

# The internal name of the service
string name

# The external, global name of the service
string resolved_name

# A human readable description of the service and how to use it
string description

# Used to group related components
string group

# The name of the message type
string message_type

# If this is a service server, otherwise it is a service client
bool server

# Indicates if this is a topic service rather than a true service
bool topic_service
"""
  __slots__ = ['name','location','nodelet_manager','description','topics','parameters','services']
  _slot_types = ['string','string','string','string','marti_introspection_msgs/TopicInfo[]','marti_introspection_msgs/ParamInfo[]','marti_introspection_msgs/ServiceInfo[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,location,nodelet_manager,description,topics,parameters,services

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(NodeInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.location is None:
        self.location = ''
      if self.nodelet_manager is None:
        self.nodelet_manager = ''
      if self.description is None:
        self.description = ''
      if self.topics is None:
        self.topics = []
      if self.parameters is None:
        self.parameters = []
      if self.services is None:
        self.services = []
    else:
      self.name = ''
      self.location = ''
      self.nodelet_manager = ''
      self.description = ''
      self.topics = []
      self.parameters = []
      self.services = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.location
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.nodelet_manager
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.topics)
      buff.write(_struct_I.pack(length))
      for val1 in self.topics:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.resolved_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.message_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.advertised
        buff.write(_get_struct_B().pack(_x))
      length = len(self.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.parameters:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.resolved_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2Bifd().pack(_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double))
        _x = val1.default_string
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_B2d().pack(_x.default_bool, _x.max_value, _x.min_value))
      length = len(self.services)
      buff.write(_struct_I.pack(length))
      for val1 in self.services:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.resolved_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.message_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.server, _x.topic_service))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.topics is None:
        self.topics = None
      if self.parameters is None:
        self.parameters = None
      if self.services is None:
        self.services = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.location = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.location = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.nodelet_manager = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.nodelet_manager = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.description = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.description = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.topics = []
      for i in range(0, length):
        val1 = marti_introspection_msgs.msg.TopicInfo()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.resolved_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.description = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.description = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.message_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.message_type = str[start:end]
        start = end
        end += 1
        (val1.advertised,) = _get_struct_B().unpack(str[start:end])
        val1.advertised = bool(val1.advertised)
        self.topics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.parameters = []
      for i in range(0, length):
        val1 = marti_introspection_msgs.msg.ParamInfo()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.resolved_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.description = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.description = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group = str[start:end]
        _x = val1
        start = end
        end += 18
        (_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double,) = _get_struct_2Bifd().unpack(str[start:end])
        val1.dynamic = bool(val1.dynamic)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.default_string = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.default_string = str[start:end]
        _x = val1
        start = end
        end += 17
        (_x.default_bool, _x.max_value, _x.min_value,) = _get_struct_B2d().unpack(str[start:end])
        val1.default_bool = bool(val1.default_bool)
        self.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.services = []
      for i in range(0, length):
        val1 = marti_introspection_msgs.msg.ServiceInfo()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.resolved_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.description = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.description = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.message_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.message_type = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.server, _x.topic_service,) = _get_struct_2B().unpack(str[start:end])
        val1.server = bool(val1.server)
        val1.topic_service = bool(val1.topic_service)
        self.services.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.location
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.nodelet_manager
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.topics)
      buff.write(_struct_I.pack(length))
      for val1 in self.topics:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.resolved_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.message_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.advertised
        buff.write(_get_struct_B().pack(_x))
      length = len(self.parameters)
      buff.write(_struct_I.pack(length))
      for val1 in self.parameters:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.resolved_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2Bifd().pack(_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double))
        _x = val1.default_string
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_B2d().pack(_x.default_bool, _x.max_value, _x.min_value))
      length = len(self.services)
      buff.write(_struct_I.pack(length))
      for val1 in self.services:
        _x = val1.name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.resolved_name
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.description
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.group
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1.message_type
        length = len(_x)
        if python3 or type(_x) == unicode:
          _x = _x.encode('utf-8')
          length = len(_x)
        buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
        _x = val1
        buff.write(_get_struct_2B().pack(_x.server, _x.topic_service))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.topics is None:
        self.topics = None
      if self.parameters is None:
        self.parameters = None
      if self.services is None:
        self.services = None
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.location = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.location = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.nodelet_manager = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.nodelet_manager = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.description = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.description = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.topics = []
      for i in range(0, length):
        val1 = marti_introspection_msgs.msg.TopicInfo()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.resolved_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.description = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.description = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.message_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.message_type = str[start:end]
        start = end
        end += 1
        (val1.advertised,) = _get_struct_B().unpack(str[start:end])
        val1.advertised = bool(val1.advertised)
        self.topics.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.parameters = []
      for i in range(0, length):
        val1 = marti_introspection_msgs.msg.ParamInfo()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.resolved_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.description = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.description = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group = str[start:end]
        _x = val1
        start = end
        end += 18
        (_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double,) = _get_struct_2Bifd().unpack(str[start:end])
        val1.dynamic = bool(val1.dynamic)
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.default_string = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.default_string = str[start:end]
        _x = val1
        start = end
        end += 17
        (_x.default_bool, _x.max_value, _x.min_value,) = _get_struct_B2d().unpack(str[start:end])
        val1.default_bool = bool(val1.default_bool)
        self.parameters.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.services = []
      for i in range(0, length):
        val1 = marti_introspection_msgs.msg.ServiceInfo()
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.resolved_name = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.description = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.description = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.group = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.group = str[start:end]
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1.message_type = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1.message_type = str[start:end]
        _x = val1
        start = end
        end += 2
        (_x.server, _x.topic_service,) = _get_struct_2B().unpack(str[start:end])
        val1.server = bool(val1.server)
        val1.topic_service = bool(val1.topic_service)
        self.services.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2B = None
def _get_struct_2B():
    global _struct_2B
    if _struct_2B is None:
        _struct_2B = struct.Struct("<2B")
    return _struct_2B
_struct_2Bifd = None
def _get_struct_2Bifd():
    global _struct_2Bifd
    if _struct_2Bifd is None:
        _struct_2Bifd = struct.Struct("<2Bifd")
    return _struct_2Bifd
_struct_B = None
def _get_struct_B():
    global _struct_B
    if _struct_B is None:
        _struct_B = struct.Struct("<B")
    return _struct_B
_struct_B2d = None
def _get_struct_B2d():
    global _struct_B2d
    if _struct_B2d is None:
        _struct_B2d = struct.Struct("<B2d")
    return _struct_B2d
