# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from marti_introspection_msgs/ParamInfo.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct


class ParamInfo(genpy.Message):
  _md5sum = "7fd9515e21aa85a018b2e533f4b39bf7"
  _type = "marti_introspection_msgs/ParamInfo"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# This message contains documentation data about a parameter in a node
uint8 TYPE_XMLRPC=0
uint8 TYPE_DOUBLE=1
uint8 TYPE_STRING=2
uint8 TYPE_INT=3
uint8 TYPE_FLOAT=4
uint8 TYPE_BOOL=5

# The internal name of the parameter
string name

# The external, global name of the parameter
string resolved_name

# A description of the parameter and what it does
string description

# Used to group related components
string group

# The type of parameter using the enums above
uint8 type

# If the parameter is dynamic or not
bool dynamic

# Default values
int32 default_int
float32 default_float
float64 default_double
string default_string
bool default_bool

# Max and minimum values (may have rounding issues)
# Unused if both are 0.0
float64 max_value
float64 min_value
"""
  # Pseudo-constants
  TYPE_XMLRPC = 0
  TYPE_DOUBLE = 1
  TYPE_STRING = 2
  TYPE_INT = 3
  TYPE_FLOAT = 4
  TYPE_BOOL = 5

  __slots__ = ['name','resolved_name','description','group','type','dynamic','default_int','default_float','default_double','default_string','default_bool','max_value','min_value']
  _slot_types = ['string','string','string','string','uint8','bool','int32','float32','float64','string','bool','float64','float64']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       name,resolved_name,description,group,type,dynamic,default_int,default_float,default_double,default_string,default_bool,max_value,min_value

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(ParamInfo, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.name is None:
        self.name = ''
      if self.resolved_name is None:
        self.resolved_name = ''
      if self.description is None:
        self.description = ''
      if self.group is None:
        self.group = ''
      if self.type is None:
        self.type = 0
      if self.dynamic is None:
        self.dynamic = False
      if self.default_int is None:
        self.default_int = 0
      if self.default_float is None:
        self.default_float = 0.
      if self.default_double is None:
        self.default_double = 0.
      if self.default_string is None:
        self.default_string = ''
      if self.default_bool is None:
        self.default_bool = False
      if self.max_value is None:
        self.max_value = 0.
      if self.min_value is None:
        self.min_value = 0.
    else:
      self.name = ''
      self.resolved_name = ''
      self.description = ''
      self.group = ''
      self.type = 0
      self.dynamic = False
      self.default_int = 0
      self.default_float = 0.
      self.default_double = 0.
      self.default_string = ''
      self.default_bool = False
      self.max_value = 0.
      self.min_value = 0.

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.resolved_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2Bifd().pack(_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double))
      _x = self.default_string
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B2d().pack(_x.default_bool, _x.max_value, _x.min_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.resolved_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.description = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.description = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.group = str[start:end]
      _x = self
      start = end
      end += 18
      (_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double,) = _get_struct_2Bifd().unpack(str[start:end])
      self.dynamic = bool(self.dynamic)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.default_string = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.default_string = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.default_bool, _x.max_value, _x.min_value,) = _get_struct_B2d().unpack(str[start:end])
      self.default_bool = bool(self.default_bool)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self.name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.resolved_name
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.description
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self.group
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_2Bifd().pack(_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double))
      _x = self.default_string
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_B2d().pack(_x.default_bool, _x.max_value, _x.min_value))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      end = 0
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.resolved_name = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.resolved_name = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.description = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.description = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.group = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.group = str[start:end]
      _x = self
      start = end
      end += 18
      (_x.type, _x.dynamic, _x.default_int, _x.default_float, _x.default_double,) = _get_struct_2Bifd().unpack(str[start:end])
      self.dynamic = bool(self.dynamic)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.default_string = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.default_string = str[start:end]
      _x = self
      start = end
      end += 17
      (_x.default_bool, _x.max_value, _x.min_value,) = _get_struct_B2d().unpack(str[start:end])
      self.default_bool = bool(self.default_bool)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2Bifd = None
def _get_struct_2Bifd():
    global _struct_2Bifd
    if _struct_2Bifd is None:
        _struct_2Bifd = struct.Struct("<2Bifd")
    return _struct_2Bifd
_struct_B2d = None
def _get_struct_B2d():
    global _struct_B2d
    if _struct_B2d is None:
        _struct_B2d = struct.Struct("<B2d")
    return _struct_B2d
